Index: /LMDZ5/branches/testing/libf/dyn3d_common/enercin.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/enercin.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/enercin.F90	(revision 2408)
@@ -0,0 +1,71 @@
+SUBROUTINE enercin ( vcov, ucov, vcont, ucont, ecin )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van.
+!-------------------------------------------------------------------------------
+! Purpose: Compute kinetic energy at sigma levels.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: vcov    (ip1jm,  llm)
+  REAL, INTENT(IN)  :: ucov    (ip1jmp1,llm)
+  REAL, INTENT(IN)  :: vcont   (ip1jm,  llm)
+  REAL, INTENT(IN)  :: ucont   (ip1jmp1,llm)
+  REAL, INTENT(OUT) :: ecin    (ip1jmp1,llm)
+!===============================================================================
+! Notes:
+!                 . V
+!                i,j-1
+!
+!      alpha4 .       . alpha1
+!
+!
+!        U .      . P     . U
+!       i-1,j    i,j      i,j
+!
+!      alpha3 .       . alpha2
+!
+!
+!                 . V
+!                i,j
+!
+! Kinetic energy at scalar point P(i,j) (excluding poles) is:
+!       Ecin = 0.5 * U(i-1,j)**2 *( alpha3 + alpha4 )  +
+!              0.5 * U(i  ,j)**2 *( alpha1 + alpha2 )  +
+!              0.5 * V(i,j-1)**2 *( alpha1 + alpha4 )  +
+!              0.5 * V(i,  j)**2 *( alpha2 + alpha3 )
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ij, i
+  REAL    :: ecinni(iip1), ecinsi(iip1), ecinpn, ecinps
+!===============================================================================
+  DO l=1,llm
+    DO ij = iip2, ip1jm -1
+      ecin(ij+1,l)=0.5*(ucov(ij    ,l)*ucont(ij    ,l)*alpha3p4(ij +1)          &
+                      + ucov(ij+1  ,l)*ucont(ij+1  ,l)*alpha1p2(ij +1)          &
+                      + vcov(ij-iim,l)*vcont(ij-iim,l)*alpha1p4(ij +1)          &
+                      + vcov(ij+1  ,l)*vcont(ij+1  ,l)*alpha2p3(ij +1) )
+    END DO
+    !--- Correction: ecin(1,j,l)= ecin(iip1,j,l)
+    DO ij=iip2,ip1jm,iip1; ecin(ij,l) = ecin(ij+iim,l); END DO
+
+    !--- North pole
+    DO i=1,iim
+      ecinni(i) = vcov(i,l)*vcont(i,l)*aire(i)
+    END DO
+    ecinpn = 0.5*SUM(ecinni(1:iim))/apoln
+    DO ij=1,iip1; ecin(ij,l)=ecinpn; END DO
+
+    !--- South pole
+    DO i=1,iim
+      ecinsi(i) = vcov(i+ip1jmi1,l)*vcont(i+ip1jmi1,l)*aire(i+ip1jm)
+    END DO
+    ecinps = 0.5*SUM(ecinsi(1:iim))/apols
+    DO ij=1,iip1; ecin(ij+ip1jm,l)=ecinps; END DO
+  END DO
+
+END SUBROUTINE enercin
+
Index: /LMDZ5/branches/testing/libf/dyn3d_common/flumass.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/flumass.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/flumass.F90	(revision 2408)
@@ -0,0 +1,76 @@
+SUBROUTINE flumass (massebx,masseby, vcont, ucont, pbaru, pbarv )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux at s levels.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: massebx(ip1jmp1,llm)
+  REAL, INTENT(IN)  :: masseby(ip1jm  ,llm)
+  REAL, INTENT(IN)  :: vcont  (ip1jm  ,llm)
+  REAL, INTENT(IN)  :: ucont  (ip1jmp1,llm)
+  REAL, INTENT(OUT) :: pbaru  (ip1jmp1,llm)
+  REAL, INTENT(OUT) :: pbarv  (ip1jm  ,llm)
+!===============================================================================
+! Method used:   A 2 equations system is solved.
+!   * 1st one describes divergence computation at pole point nr. i (i=1 to im):
+!     (0.5*(pbaru(i)-pbaru(i-1))-pbarv(i))/aire(i) = - SUM(pbarv(n))/aire pole
+!   * 2nd one specifies that mean mass flux at pole is equal to 0:
+!     SUM(pbaru(n)*local_area(n))=0
+! This way, we determine additive constant common to pbary elements representing
+!   pbaru(0,j,l) in divergence computation equation for point i=1. (i=1 to im)
+!===============================================================================
+! Local variables:
+  REAL    :: sairen, saireun, ctn, ctn0, apbarun(iip1)
+  REAL    :: saires, saireus, cts, cts0, apbarus(iip1)
+  INTEGER :: l, i
+!===============================================================================
+  DO l=1,llm
+    pbaru(iip2:ip1jm,l)=massebx(iip2:ip1jm,l)*ucont(iip2:ip1jm,l)
+    pbarv(   1:ip1jm,l)=masseby(   1:ip1jm,l)*vcont(   1:ip1jm,l)
+  END DO
+
+  !--- NORTH POLE
+  sairen =SUM(aire (1:iim))
+  saireun=SUM(aireu(1:iim))
+  DO l = 1,llm
+    ctn=SUM(pbarv(1:iim,l))/sairen
+    pbaru(1,l)= pbarv(1,l)-ctn*aire(1)
+    DO i=2,iim
+      pbaru(i,l)=pbaru(i-1,l)+pbarv(i,l)-ctn*aire(i)
+    END DO
+    DO i=1,iim
+      apbarun(i)=aireu(i)*pbaru(i,l)
+    END DO
+    ctn0 = -SUM(apbarun(1:iim))/saireun
+    DO i = 1,iim
+      pbaru(i,l)=2.*(pbaru(i,l)+ctn0)
+    END DO
+    pbaru(iip1,l)=pbaru(1,l)
+  END DO
+
+  !--- SOUTH POLE
+  saires =SUM(aire (ip1jm+1:ip1jmp1-1))
+  saireus=SUM(aireu(ip1jm+1:ip1jmp1-1))
+  DO l = 1,llm
+    cts=SUM(pbarv(ip1jmi1+1:ip1jm-1,l))/saires
+    pbaru(1+ip1jm,l)=-pbarv(1+ip1jmi1,l)+cts*aire(1+ip1jm)
+    DO i=2,iim
+      pbaru(i+ip1jm,l)=pbaru(i-1+ip1jm,l)-pbarv(i+ip1jmi1,l)+cts*aire(i+ip1jm)
+    END DO
+    DO i=1,iim
+      apbarus(i)=aireu(i+ip1jm)*pbaru(i+ip1jm,l)
+    END DO
+    cts0 = -SUM(apbarus(1:iim))/saireus
+    DO i = 1,iim
+      pbaru(i+ip1jm,l)=2.*(pbaru(i+ip1jm,l)+cts0)
+    END DO
+    pbaru(ip1jmp1,l)=pbaru(1+ip1jm,l)
+  END DO
+
+END SUBROUTINE flumass
Index: /LMDZ5/branches/testing/libf/dyn3d_common/infotrac.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/infotrac.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/infotrac.F90	(revision 2408)
@@ -59,5 +59,5 @@
 
   SUBROUTINE infotrac_init
-    USE control_mod
+    USE control_mod, ONLY: planet_type, config_inca
 #ifdef REPROBUS
     USE CHEM_REP, ONLY : Init_chem_rep_trac
@@ -196,11 +196,13 @@
           nqo=2
        ENDIF
-       IF (nqo /= 2 .OR. nqo /= 3 ) THEN
+       IF (nqo /= 2 .AND. nqo /= 3 ) THEN
           WRITE(lunout,*) trim(modname),': nqo=',nqo, ' is not allowded. Only 2 or 3 water phases allowed'
           CALL abort_gcm('infotrac_init','Bad number of water phases',1)
        END IF
        ! nbtr has been read from INCA by init_const_lmdz() in gcm.F 
+#ifdef INCA
+       CALL Init_chem_inca_trac(nbtr) 
+#endif       
        nqtrue=nbtr+nqo
-!!       nqtrue=nbtr+2
     END IF   ! type_trac
 !>jyg
@@ -274,15 +276,15 @@
              ! Y-a-t-il 1 ou 2 noms de traceurs? -> On regarde s'il y a un
              ! espace ou pas au milieu de la chaine.
-             continu=1
-             nouveau_traceurdef=0
+             continu=.true.
+             nouveau_traceurdef=.false.
              iiq=1
              do while (continu)
                 if (tchaine(iiq:iiq).eq.' ') then
-                  nouveau_traceurdef=1
-                  continu=0
+                  nouveau_traceurdef=.true.
+                  continu=.false.
                 else if (iiq.lt.LEN_TRIM(tchaine)) then
                   iiq=iiq+1
                 else
-                  continu=0      
+                  continu=.false.
                 endif
              enddo
@@ -384,10 +386,16 @@
 #endif
        tnom_0(1)='H2Ov'
+       tnom_transp(1) = 'air'
        tnom_0(2)='H2Ol'
-       IF (nqo == 3) tnom_0(3)='H2Oi'     !! jyg
+       tnom_transp(2) = 'air'
+       IF (nqo == 3) then 
+          tnom_0(3)='H2Oi'     !! jyg
+          tnom_transp(3) = 'air'
+       endif
 
 !jyg<
        DO iq = nqo+1, nqtrue
           tnom_0(iq)=solsym(iq-nqo)
+          tnom_transp(iq) = 'air'
        END DO
 !!       DO iq =3,nqtrue
@@ -672,12 +680,12 @@
 
     do iq=nqo+1,nqtot
-       write(lunout,*) 'infotrac 569: iq,tnom_0(iq)=',iq,tnom_0(iq)
+!       write(lunout,*) 'infotrac 569: iq,tnom_0(iq)=',iq,tnom_0(iq)
        do phase=1,nqo    
         do ixt= 1,niso_possibles   
          tnom_trac=trim(tnom_0(phase))//'_'
          tnom_trac=trim(tnom_trac)//trim(tnom_iso(ixt))
-         write(*,*) 'phase,ixt,tnom_trac=',phase,ixt,tnom_trac      
+!         write(*,*) 'phase,ixt,tnom_trac=',phase,ixt,tnom_trac      
          IF (tnom_0(iq) == tnom_trac) then
-          write(lunout,*) 'Ce traceur est un isotope'
+!          write(lunout,*) 'Ce traceur est un isotope'
           nb_iso(ixt,phase)=nb_iso(ixt,phase)+1   
           nb_isoind(phase)=nb_isoind(phase)+1   
@@ -686,12 +694,12 @@
           indnum_fn_num(ixt)=iso_indnum(iq)
           phase_num(iq)=phase
-          write(lunout,*) 'iso_num(iq)=',iso_num(iq)
-          write(lunout,*) 'iso_indnum(iq)=',iso_indnum(iq)
-          write(lunout,*) 'indnum_fn_num(ixt)=',indnum_fn_num(ixt)
-          write(lunout,*) 'phase_num(iq)=',phase_num(iq)
+!          write(lunout,*) 'iso_num(iq)=',iso_num(iq)
+!          write(lunout,*) 'iso_indnum(iq)=',iso_indnum(iq)
+!          write(lunout,*) 'indnum_fn_num(ixt)=',indnum_fn_num(ixt)
+!          write(lunout,*) 'phase_num(iq)=',phase_num(iq)
           goto 20
          else if (iqpere(iq).gt.0) then          
           if (tnom_0(iqpere(iq)) == tnom_trac) then
-           write(lunout,*) 'Ce traceur est le fils d''un isotope'
+!           write(lunout,*) 'Ce traceur est le fils d''un isotope'
            ! c'est un traceur d'isotope
            nb_traciso(ixt,phase)=nb_traciso(ixt,phase)+1
@@ -700,7 +708,7 @@
            zone_num(iq)=nb_traciso(ixt,phase)
            phase_num(iq)=phase
-           write(lunout,*) 'iso_num(iq)=',iso_num(iq)
-           write(lunout,*) 'phase_num(iq)=',phase_num(iq)
-           write(lunout,*) 'zone_num(iq)=',zone_num(iq)
+!           write(lunout,*) 'iso_num(iq)=',iso_num(iq)
+!           write(lunout,*) 'phase_num(iq)=',phase_num(iq)
+!           write(lunout,*) 'zone_num(iq)=',zone_num(iq)
            goto 20
           endif !if (tnom_0(iqpere(iq)) == trim(tnom_0(phase))//trim(tnom_iso(ixt))) then
@@ -711,9 +719,9 @@
       enddo !do iq=1,nqtot
 
-      write(lunout,*) 'iso_num=',iso_num
-      write(lunout,*) 'iso_indnum=',iso_indnum
-      write(lunout,*) 'zone_num=',zone_num  
-      write(lunout,*) 'phase_num=',phase_num
-      write(lunout,*) 'indnum_fn_num=',indnum_fn_num
+!      write(lunout,*) 'iso_num=',iso_num
+!      write(lunout,*) 'iso_indnum=',iso_indnum
+!      write(lunout,*) 'zone_num=',zone_num  
+!      write(lunout,*) 'phase_num=',phase_num
+!      write(lunout,*) 'indnum_fn_num=',indnum_fn_num
 
       do ixt= 1,niso_possibles  
@@ -724,5 +732,5 @@
           do phase=2,nqo
             if (nb_iso(ixt,phase).ne.nb_iso(ixt,1)) then
-              write(lunout,*) 'ixt,phase,nb_iso=',ixt,phase,nb_iso(ixt,phase)
+!              write(lunout,*) 'ixt,phase,nb_iso=',ixt,phase,nb_iso(ixt,phase)
               CALL abort_gcm('infotrac_init','Phases must have same number of isotopes',1)
             endif
@@ -763,6 +771,6 @@
     ! dimensions isotopique:
     ntraciso=niso*(ntraceurs_zone+1)
-    WRITE(lunout,*) 'niso=',niso
-    WRITE(lunout,*) 'ntraceurs_zone,ntraciso=',ntraceurs_zone,ntraciso    
+!    WRITE(lunout,*) 'niso=',niso
+!    WRITE(lunout,*) 'ntraceurs_zone,ntraciso=',ntraceurs_zone,ntraciso    
  
     ! flags isotopiques:
@@ -772,5 +780,5 @@
         ok_isotopes=.false.
     endif 
-    WRITE(lunout,*) 'ok_isotopes=',ok_isotopes
+!    WRITE(lunout,*) 'ok_isotopes=',ok_isotopes
  
     if (ok_isotopes) then
@@ -782,6 +790,6 @@
         alpha_ideal=(/1.0,1.01,1.006,1.003,1.0/)
     endif !if (ok_isotopes) then  
-    WRITE(lunout,*) 'ok_iso_verif=',ok_iso_verif
-    WRITE(lunout,*) 'ok_init_iso=',ok_init_iso
+!    WRITE(lunout,*) 'ok_iso_verif=',ok_iso_verif
+!    WRITE(lunout,*) 'ok_init_iso=',ok_init_iso
 
     if (ntraceurs_zone.gt.0) then
@@ -790,5 +798,5 @@
         ok_isotrac=.false.
     endif   
-    WRITE(lunout,*) 'ok_isotrac=',ok_isotrac
+!    WRITE(lunout,*) 'ok_isotrac=',ok_isotrac
 
     ! remplissage du tableau iqiso(ntraciso,phase)
@@ -801,5 +809,5 @@
         endif
     enddo
-    WRITE(lunout,*) 'iqiso=',iqiso
+!    WRITE(lunout,*) 'iqiso=',iqiso
 
     ! replissage du tableau index_trac(ntraceurs_zone,niso)
@@ -814,5 +822,5 @@
         index_trac(:,:)=0.0
     endif !if (ok_isotrac) then
-    write(lunout,*) 'index_trac=',index_trac    
+!    write(lunout,*) 'index_trac=',index_trac    
 
 ! Finalize :
Index: /LMDZ5/branches/testing/libf/dyn3d_common/massbar.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/massbar.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/massbar.F90	(revision 2408)
@@ -0,0 +1,66 @@
+SUBROUTINE massbar(masse,massebx,masseby)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse  (ip1jmp1,llm)
+  REAL, INTENT(OUT) :: massebx(ip1jmp1,llm)
+  REAL, INTENT(OUT) :: masseby(ip1jm  ,llm)
+!-------------------------------------------------------------------------------
+! Method used. Each scalar point is associated to 4 area coefficients:
+!    * alpha1(i,j) at point ( i+1/4,j-1/4 )
+!    * alpha2(i,j) at point ( i+1/4,j+1/4 )
+!    * alpha3(i,j) at point ( i-1/4,j+1/4 )
+!    * alpha4(i,j) at point ( i-1/4,j-1/4 )
+! where alpha1(i,j) = aire(i+1/4,j-1/4)/ aire(i,j)
+!
+!   alpha4 .         . alpha1    . alpha4
+!    (i,j)             (i,j)       (i+1,j)
+!
+!             P .        U .          . P
+!           (i,j)       (i,j)         (i+1,j)
+!
+!   alpha3 .         . alpha2    .alpha3 
+!    (i,j)              (i,j)     (i+1,j)
+!
+!             V .        Z .          . V
+!           (i,j)
+!
+!   alpha4 .         . alpha1    .alpha4
+!   (i,j+1)            (i,j+1)   (i+1,j+1) 
+!
+!             P .        U .          . P
+!          (i,j+1)                    (i+1,j+1)
+!
+!
+!    massebx(i,j) = masse(i  ,j) * ( alpha1(i  ,j) + alpha2(i,j))   +
+!                   masse(i+1,j) * ( alpha3(i+1,j) + alpha4(i+1,j) )
+!     localized at point  ... U (i,j) ...
+!
+!    masseby(i,j) = masse(i,j  ) * ( alpha2(i,j  ) + alpha3(i,j  )  +
+!                   masse(i,j+1) * ( alpha1(i,j+1) + alpha4(i,j+1)  
+!     localized at point  ... V (i,j) ...
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l
+!===============================================================================
+  DO l=1,llm
+    DO ij=1,ip1jmp1-1
+      massebx(ij,l)=masse(ij,l)*alpha1p2(ij)+masse(ij+1   ,l)*alpha3p4(ij+1)
+    END DO
+    DO ij=iip1,ip1jmp1,iip1; massebx(ij,l)=massebx(ij-iim,l); END DO
+    DO ij=1,ip1jm
+      masseby(ij,l)=masse(ij,l)*alpha2p3(ij)+masse(ij+iip1,l)*alpha1p4(ij+iip1)
+    END DO
+  END DO
+
+END SUBROUTINE massbar
+
Index: /LMDZ5/branches/testing/libf/dyn3d_common/massbarxy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/massbarxy.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/massbarxy.F90	(revision 2408)
@@ -0,0 +1,31 @@
+SUBROUTINE massbarxy(masse,massebxy)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse   (ip1jmp1,llm)
+  REAL, INTENT(OUT) :: massebxy(ip1jm  ,llm)
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l
+!===============================================================================
+  DO l=1,llm
+    DO ij=1,ip1jm-1
+      massebxy(ij,l)=masse(ij     ,l)*alpha2(ij     ) + &
+     +               masse(ij+1   ,l)*alpha3(ij+1   ) + &
+     +               masse(ij+iip1,l)*alpha1(ij+iip1) + &
+     +               masse(ij+iip2,l)*alpha4(ij+iip2)
+    END DO
+    DO ij=iip1,ip1jm,iip1; massebxy(ij,l)=massebxy(ij-iim,l); END DO
+  END DO
+
+END SUBROUTINE massbarxy
Index: /LMDZ5/branches/testing/libf/dyn3d_common/misc_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/misc_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/misc_mod.F90	(revision 2408)
@@ -0,0 +1,6 @@
+module misc_mod
+  integer,save :: itaumax
+  logical,save :: adjust
+  integer,save :: ItCount
+  logical,save :: debug
+end module misc_mod 
Index: /LMDZ5/branches/testing/libf/dyn3d_common/pression.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/pression.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/pression.F90	(revision 2408)
@@ -0,0 +1,27 @@
+SUBROUTINE pression( ngrid, ap, bp, ps, p )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr.Hourdin 
+!-------------------------------------------------------------------------------
+! Purpose: Compute pressure p(l) at different levels from l = 1 (ground level)
+!          to l = llm +1. Those levels correspond to the llm layers interfaces,
+!          with p(ij,llm+1) = 0. and  p(ij,1) = ps(ij)  .   
+!-------------------------------------------------------------------------------
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+!===============================================================================
+! Arguments:
+  INTEGER, INTENT(IN)  :: ngrid                 !--- NUMBER OF GRID POINTS
+  REAL,    INTENT(IN)  :: ap(llmp1), bp(llmp1)  !--- HYBRID COEFFICIENTS
+  REAL,    INTENT(IN)  :: ps(ngrid)             !--- SURFACE PRESSURE
+  REAL,    INTENT(OUT) :: p(ngrid,llmp1)        !--- 3D PRESSURE FIELD 
+!===============================================================================
+! Local variables:
+  INTEGER :: l
+!===============================================================================
+  DO l=1,llmp1;  p(:,l) = ap(l) + bp(l) * ps(:);  END DO
+
+END SUBROUTINE pression
+
+
Index: /LMDZ5/branches/testing/libf/dyn3d_common/tourpot.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/tourpot.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/tourpot.F90	(revision 2408)
@@ -0,0 +1,46 @@
+SUBROUTINE tourpot ( vcov, ucov, massebxy, vorpot )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van.
+!-------------------------------------------------------------------------------
+! Purpose: Compute potential vorticity.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: vcov    (ip1jm,  llm)
+  REAL, INTENT(IN)  :: ucov    (ip1jmp1,llm)
+  REAL, INTENT(IN)  :: massebxy(ip1jm,  llm)
+  REAL, INTENT(OUT) :: vorpot  (ip1jm,  llm)
+!===============================================================================
+! Method used:
+!   vorpot = ( Filtre( d(vcov)/dx - d(ucov)/dy ) + fext ) /psbarxy
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ij
+  REAL    :: rot(ip1jm,llm)
+!===============================================================================
+
+!--- Wind vorticity ; correction: rot(iip1,j,l) = rot(1,j,l)
+  DO l=1,llm
+    DO ij=1,ip1jm-1
+      rot(ij,l)=vcov(ij+1,l)-vcov(ij,l)+ucov(ij+iip1,l)-ucov(ij,l)
+    END DO
+    DO ij=iip1,ip1jm,iip1; rot(ij,l)=rot(ij-iim,l); END DO
+  END DO
+
+!--- Filter
+  CALL  filtreg(rot,jjm,llm,2,1,.FALSE.,1)
+
+!--- Potential vorticity ; correction: rot(iip1,j,l) = rot(1,j,l)
+  DO l=1,llm
+    DO ij=1,ip1jm-1
+      vorpot(ij,l)=(rot(ij,l)+fext(ij))/massebxy(ij,l)
+    END DO
+    DO ij=iip1,ip1jm,iip1; vorpot(ij,l)=vorpot(ij-iim,l); END DO
+  END DO
+
+END SUBROUTINE tourpot
Index: /LMDZ5/branches/testing/libf/dyn3d_common/vitvert.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/vitvert.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/vitvert.F90	(revision 2408)
@@ -0,0 +1,27 @@
+SUBROUTINE vitvert (convm, w)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute vertical speed at sigma levels.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comvert.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: convm(ip1jmp1,llm)
+  REAL, INTENT(OUT) :: w    (ip1jmp1,llm)
+!===============================================================================
+! Notes: Vertical speed is oriented from bottom to top.
+!   * At ground - level sigma(1):     w(i,j,1) = 0.
+!   * At top    - level sigma(llm+1): w(i,j,l) = 0. (not stored in w)
+!===============================================================================
+! Local variables:
+  INTEGER :: l
+!===============================================================================
+  DO l=1,llmm1; w(:,l+1)=convm(:,l+1)-bp(l+1)*convm(:,1); END DO
+  w(:,1)=0.
+
+END SUBROUTINE vitvert
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/bands.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/bands.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/bands.F90	(revision 2408)
@@ -105,11 +105,9 @@
    SUBROUTINE  Set_Bands 
      USE parallel_lmdz
-#ifdef CPP_PHYS
-! Ehouarn: what follows is only related to // physics
-     USE mod_phys_lmdz_para, ONLY : jj_para_begin,jj_para_end
-#endif
      IMPLICIT NONE
      INCLUDE 'dimensions.h'    
-     INTEGER :: i
+     INTEGER :: i, ij
+     INTEGER :: jj_para_begin(0:mpi_size-1)
+     INTEGER :: jj_para_end(0:mpi_size-1)
         
       do i=0,mpi_size-1
@@ -118,6 +116,16 @@
       enddo
           
-#ifdef CPP_PHYS
-      do i=0,MPI_Size-1
+      jj_para_begin(0)=1
+      ij=distrib_phys(0)+iim-1
+      jj_para_end(0)=((ij-1)/iim)+1
+      
+      DO i=1,mpi_Size-1
+        ij=ij+1
+        jj_para_begin(i)=((ij-1)/iim)+1
+        ij=ij+distrib_phys(i)-1
+        jj_para_end(i)=((ij-1)/iim)+1
+      ENDDO
+ 
+       do i=0,MPI_Size-1
         jj_Nb_physic(i)=jj_para_end(i)-jj_para_begin(i)+1
         if (i/=0) then
@@ -139,5 +147,5 @@
         endif
       enddo
-#endif      
+
       CALL create_distrib(jj_Nb_Caldyn,distrib_caldyn)
       CALL create_distrib(jj_Nb_vanleer,distrib_vanleer)
@@ -479,2 +487,3 @@
   
   
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/call_calfis_mod.F90	(revision 2408)
@@ -137,5 +137,5 @@
    
            jD_cur = jD_ref + day_ini - day_ref                           &
-     &        + itau/day_step
+     &        + (itau+1)/day_step
 
            IF (planet_type .eq."generic") THEN
@@ -145,5 +145,5 @@
 
            jH_cur = jH_ref + start_time +                                &
-     &              mod(itau,day_step)/float(day_step) 
+     &              mod(itau+1,day_step)/float(day_step) 
     if (jH_cur > 1.0 ) then
       jD_cur = jD_cur +1.
Index: /LMDZ5/branches/testing/libf/dyn3dmem/convmas1_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/convmas1_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/convmas1_loc.F90	(revision 2408)
@@ -0,0 +1,38 @@
+SUBROUTINE convmas1_loc (pbaru, pbarv, convm)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux convergence at p levels.
+!          Equivalent to convmas_loc if convmas2_loc is called after.
+  USE parallel_lmdz
+  USE mod_filtreg_p
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: pbaru(ijb_u:ije_u,llm)
+  REAL, INTENT(IN)  :: pbarv(ijb_v:ije_v,llm)
+  REAL, TARGET, INTENT(OUT) :: convm(ijb_u:ije_u,llm)
+!===============================================================================
+! Method used:   Computation from top to bottom.
+!   Mass convergence at level llm is equal to zero and is not stored in convm.
+!===============================================================================
+! Local variables:
+  INTEGER :: l, jjb, jje
+!===============================================================================
+
+!--- Computation of - (d(pbaru)/dx + d(pbarv)/dy )
+  CALL convflu_loc( pbaru, pbarv, llm, convm )
+
+!--- Filter
+  jjb=jj_begin
+  jje=jj_end+1
+  IF(pole_sud) jje=jj_end
+  CALL filtreg_p(convm,jjb_u,jje_u,jjb,jje,jjp1,llm,2,2,.TRUE.,1)
+
+END SUBROUTINE convmas1_loc
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/convmas2_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/convmas2_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/convmas2_loc.F90	(revision 2408)
@@ -0,0 +1,36 @@
+SUBROUTINE convmas2_loc (convm)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux convergence at p levels.
+!          Equivalent to convmas_loc if convmas1_loc is called before.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(INOUT) :: convm(ijb_u:ije_u,llm)
+!===============================================================================
+! Method used:   Computation from top to bottom.
+!   Mass convergence at level llm is equal to zero and is not stored in convm.
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ijb, ije
+!===============================================================================
+
+!$OMP MASTER
+!--- Mass convergence is integrated from top to bottom
+  ijb=ij_begin
+  ije=ij_end+iip1
+  IF(pole_sud) ije=ij_end
+  DO l=llmm1,1,-1
+    convm(ijb:ije,l) = convm(ijb:ije,l) + convm(ijb:ije,l+1)
+  END DO
+!$OMP END MASTER
+
+END SUBROUTINE convmas2_loc
+
Index: /LMDZ5/branches/testing/libf/dyn3dmem/convmas_loc.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dmem/convmas_loc.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3dmem/convmas_loc.F90	(revision 2408)
@@ -0,0 +1,49 @@
+SUBROUTINE convmas_loc (pbaru, pbarv, convm)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux convergence at p levels.
+  USE parallel_lmdz
+  USE mod_filtreg_p
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: pbaru(ijb_u:ije_u,llm)
+  REAL, INTENT(IN)  :: pbarv(ijb_v:ije_v,llm)
+  REAL, INTENT(OUT) :: convm(ijb_u:ije_u,llm)
+!===============================================================================
+! Method used:   Computation from top to bottom.
+!   Mass convergence at level llm is equal to zero and is not stored in convm.
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ijb, ije, jjb, jje
+!===============================================================================
+
+!--- Computation of - (d(pbaru)/dx + d(pbarv)/dy )
+  CALL convflu_loc( pbaru, pbarv, llm, convm )
+
+!--- Filter
+  jjb=jj_begin
+  jje=jj_end+1
+  IF(pole_sud) jje=jj_end
+  CALL filtreg_p(convm,jjb_u,jje_u,jjb,jje,jjp1,llm,2,2,.TRUE.,1)
+
+!--- Mass convergence is integrated from top to bottom
+!$OMP BARRIER
+!$OMP MASTER
+  ijb=ij_begin
+  ije=ij_end+iip1
+  IF(pole_sud) ije=ij_end
+  DO l=llmm1,1,-1
+    convm(ijb:ije,l) = convm(ijb:ije,l) + convm(ijb:ije,l+1)
+  END DO
+!$OMP END MASTER
+!$OMP BARRIER
+
+END SUBROUTINE convmas_loc
+
